#include <random>
#include <uuid/uuid.h>
#include <array>

std::random_device randomDevice;
std::mt19937 rng(randomDevice());

std::array<char, 64> characters = {
        'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
        'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
        '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '%', '!'
};

int UUID::dice(int min, int max) {
    std::uniform_int_distribution<> generate(min, max);
    return generate(rng);
}

std::string UUID::generateUUID(const unsigned int length) {
    std::string result;
    for (int i = 0; i < length; i++)
        result.push_back(characters[UUID::dice(0, 63)]);
    return result;
}
